### BIOMOD example in R ###

# let's use the library biomod2
library(biomod2)

setwd("~/Desktop/Lavoro/Didattica/Corso_ENM/2021/class05/exercises/biomod")

# we use a set of data which is already redy for use
# we have seen how o prepare the date in the previous classes
mammals_data <- read.csv("mammals_and_bioclim_table.csv", row.names=1)

# let's have a look at the first lines of the data frame
head(mammals_data)
# it contains occurrence records for five mammals, together with bioclimatic
# predictors which are conseidered the most significant in influencing 
# mammal distribution.

# we are doing 3 predictions, one using all the data, and two limiting the
# effect of outliers, limiting the data to the 97,5 and 95 percentile.
# in this example we use Vuples vulpes, but u can try with other data.
pred_BIOCLIM = sre(Response = mammals_data$VulpesVulpes, 
                   Explanatory = mammals_data[,c("bio3", "bio7", "bio11", "bio12")], 
                   NewData = mammals_data[,c("bio3", "bio7", "bio11", "bio12")], 
                   Quant = 0)

pred_BIOCLIM_025 = sre(Response = mammals_data$VulpesVulpes, 
                       Explanatory = mammals_data[,c("bio3", "bio7", "bio11", "bio12")], 
                       NewData = mammals_data[,c("bio3",  "bio7", "bio11", "bio12")], 
                       Quant = 0.025)

pred_BIOCLIM_05 = sre(Response = mammals_data$VulpesVulpes, 
                      Explanatory = mammals_data[,c("bio3",  "bio7", "bio11", "bio12")], 
                      NewData = mammals_data[,c("bio3",  "bio7", "bio11", "bio12")], 
                      Quant = 0.05)

# then we set the ourput window to 4 parts, and we print it all.
par(mfrow=c(2,2))

level.plot(mammals_data$VulpesVulpes, 
           XY=mammals_data[,c("X_WGS84", "Y_WGS84")], 
           color.gradient = "grey", 
           cex=0.3,show.scale=F, 
           title="Original data")

level.plot(pred_BIOCLIM, 
           XY=mammals_data[,c("X_WGS84", "Y_WGS84")], 
           color.gradient = "grey", 
           cex=0.3,show.scale=F, 
           title="BIOCLIM 100%")

level.plot(pred_BIOCLIM_025, 
           XY=mammals_data[,c("X_WGS84", "Y_WGS84")], 
           color.gradient = "grey", 
           cex=0.3,show.scale=F, 
           title="BIOCLIM 97.5%")

level.plot(pred_BIOCLIM_05, 
           XY=mammals_data[,c("X_WGS84", "Y_WGS84")], 
           color.gradient = "grey", 
           cex=0.3,show.scale=F, 
           title="BIOCLIM 95%")

par(mfrow=c(1,1))
